#include "base64.h"

void base64encod(char *src, char *dst, int size)
{
	unsigned char triplet[3];
	int   cartriplet;
	unsigned char valcode[4];
	int   pos_src;
	int   pos_dst;
	char  valcar[]="ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/=";

	pos_src = 0;
	pos_dst = 0;

	while (pos_src < size)
	{
		cartriplet = 0;

		do
			triplet [cartriplet++] = src[pos_src++];
		while (cartriplet < 3 && pos_src < size);

		valcode[0] = triplet[0] >> 2;
		valcode[1] = (triplet[0] & 3) << 4;

		if (cartriplet > 1)
		{
			valcode[1] = valcode[1] | (triplet[1] >> 4);
			valcode[2] = (triplet[1] & 0x0F) << 2;
		}
		else
			valcode[2] = 64;

		if (cartriplet == 3)
		{
			valcode[2] = valcode[2] | (triplet[2] >> 6);
			valcode[3] = triplet[2] & 0x3F;
		}
		else
			valcode [3] = 64;

		dst[pos_dst++] = valcar[valcode [0]];
		dst[pos_dst++] = valcar[valcode [1]];
		dst[pos_dst++] = valcar[valcode [2]];
		dst[pos_dst++] = valcar[valcode [3]];
	}
	dst[pos_dst] = '\0';
}

int base64decode(char *buffer)
{
	int  car;
	char valcar[4];
	int  i;
	int  pos_src; 
	int  pos_dst;

	pos_src = 0;
	pos_dst = 0;

	while (buffer[pos_src] > ' ' && buffer[pos_src] != '=')
	{
		for (i = 0; i < 4 && buffer[pos_src] != '='; i++)
		{
			car = buffer[pos_src++];

			if ('A' <= car && car <= 'Z')
				valcar[i] = car - 'A';
			else if ('a' <= car && car <= 'z')
				valcar[i] = car + 26 - 'a';
			else if ('0' <= car && car <= '9')
				valcar[i] = car + 52 - '0';
			else if (car == '+')
				valcar[i] = 62;
			else if (car == '/')
				valcar[i] = 63;
		}

		buffer[pos_dst++] = (valcar[0] << 2) | (valcar[1] >> 4);

		if (i > 2)
		{
			buffer[pos_dst++] = (valcar[1] << 4) | (valcar[2] >> 2);

			if (i > 3)
				buffer[pos_dst++] = (valcar[2] << 6) | (valcar[3]);
		}
	}
	buffer[pos_dst] = '\0';

	return (pos_dst);
}
